﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Energiemonitor
{
    public class Zaehlerdaten
    {
        public string Datum;
        public string Uhrzeit;
        public uint UTC;
        public uint Strom;
        public uint Gas;
        public uint Wasser;
        public int Temperatur1;
        public int Temperatur2;
        public int Temperatur3;
        public int Temperatur4;
        public int Temperatur5;
        public int Temperatur6;
        public int Temperatur7;
        public int Temperatur8;

        public uint MomentStrom;
        public uint MomentGas;
        public uint MomentWasser;

        //-----------------------------------------------------------------------------------------------
        // Zerlegt eine reinkommende Textzeile aus der Rohdatendatei in das passende Struct (siehe oben)
        //-----------------------------------------------------------------------------------------------
        public Zaehlerdaten(string filestr)
        {
            string[] arr = filestr.Split(' ');

            if (arr.Length >= 14)
            {
                if (arr[1] != "")
                {

                    Datum = arr[0];
                    Uhrzeit = arr[1];
                    UTC = (uint)Convert.ToInt64(arr[2], 16);
                    Strom = (uint)Convert.ToInt64(arr[3], 16);
                    Gas = (uint)Convert.ToInt64(arr[4], 16);
                    Wasser = (uint)Convert.ToInt64(arr[5], 16);
                    Temperatur1 = Convert.ToInt32(arr[6], 16) - 50;
                    Temperatur2 = Convert.ToInt32(arr[7], 16) - 50;
                    Temperatur3 = Convert.ToInt32(arr[8], 16) - 50;
                    Temperatur4 = Convert.ToInt32(arr[9], 16) - 50;
                    Temperatur5 = Convert.ToInt32(arr[10], 16) - 50;
                    Temperatur6 = Convert.ToInt32(arr[11], 16) - 50;
                    Temperatur7 = Convert.ToInt32(arr[12], 16) - 50;
                    Temperatur8 = Convert.ToInt32(arr[13], 16) - 50;
                }
            }

        }

    }

    // Vom Versorger abgelesene Daten an den Zählern zum jeweiligen Datum
    public class Kosten
    {
        public uint DatumUTC;
        public float StromGrundpreis;
        public float StromArbeitspreis;
        public float GasGrundpreis;
        public float Gararbeitspreis;
        public float WasserGrundpreis;
        public float WasserArbeitspreis;
        public float GasUmrechnungsfaktor;


        //-----------------------------------------------------------------------------------------------
        // Zerlegt eine reinkommende Textzeile aus der Rohdatendatei in das passende Struct (siehe oben)
        //-----------------------------------------------------------------------------------------------
        public Kosten(string filestr)
        {
            System.DateTime localDateTime;
            string[] arr = filestr.Split(' ');

            if (arr.Length >= 7)
            {
                if (arr[1] != "")
                {
                    localDateTime = System.DateTime.Parse(arr[0]);
                    DateTime RefDate = new DateTime(1970, 1, 1);                      //Referenzdatum (festgelegt)
                    TimeSpan ts = new TimeSpan(localDateTime.Ticks - RefDate.Ticks);  // das Delta ermitteln

                    DatumUTC = (uint)Convert.ToInt32(ts.TotalSeconds);
                    StromGrundpreis = (float)Convert.ToDouble(arr[1]);
                    StromArbeitspreis = (float)Convert.ToDouble(arr[2]);
                    GasGrundpreis = (float)Convert.ToDouble(arr[3]);
                    Gararbeitspreis = (float)Convert.ToDouble(arr[4]);
                    GasUmrechnungsfaktor = (float)Convert.ToDouble(arr[5]);
                    WasserGrundpreis = (float)Convert.ToDouble(arr[6]);
                    WasserArbeitspreis = (float)Convert.ToDouble(arr[7]);
                }
            }

        }

    }

    public class Ablesungen
    {
        public uint DatumStrom;       // Wann wurde der Zähler abgelesen
        public uint StandStrom;     // Mit welchem Stand wurde er ausgelesen 

        public uint DatumGas;       // Wann wurde der Zähler abgelesen
        public uint StandGas;     // Mit welchem Stand wurde er ausgelesen 

        public uint DatumWasser;       // Wann wurde der Zähler abgelesen
        public uint StandWasser;     // Mit welchem Stand wurde er ausgelesen 

        public Ablesungen(string filestr)
        {
            System.DateTime localDateTime;
            string[] arr = filestr.Split(' ');
            // 17.10.2010 43086 17.10.2010 42047 17.03.2011 355
            if (arr.Length >= 6)
            {
                if (arr[1] != "")
                {
                    localDateTime = System.DateTime.Parse(arr[0]);
                    DateTime RefDate = new DateTime(1970, 1, 1);                      //Referenzdatum (festgelegt)
                    TimeSpan ts = new TimeSpan(localDateTime.Ticks - RefDate.Ticks);  // das Delta ermitteln
                    DatumStrom = (uint)Convert.ToInt32(ts.TotalSeconds);

                    StandStrom = (uint)Convert.ToInt32(arr[1]);

                    localDateTime = System.DateTime.Parse(arr[2]);
                    ts = new TimeSpan(localDateTime.Ticks - RefDate.Ticks);  // das Delta ermitteln
                    DatumGas = (uint)Convert.ToInt32(ts.TotalSeconds);

                    StandGas = (uint)Convert.ToInt32(arr[3]);

                    localDateTime = System.DateTime.Parse(arr[4]);
                    ts = new TimeSpan(localDateTime.Ticks - RefDate.Ticks);  // das Delta ermitteln
                    DatumWasser = (uint)Convert.ToInt32(ts.TotalSeconds);

                    StandWasser = (uint)Convert.ToInt32(arr[5]);

                }
            }

        }


    }

    public class Abschlaege
    {
        // 01.01.2011 71,00 84,00 20,50
        public uint Datum;
        public float Strom;
        public float Gas;
        public float Wasser;

        public Abschlaege(string filestr)
        {
            System.DateTime localDateTime;
            string[] arr = filestr.Split(' ');

            if (arr.Length >= 4)
            {
                if (arr[1] != "")
                {
                    localDateTime = System.DateTime.Parse(arr[0]);
                    DateTime RefDate = new DateTime(1970, 1, 1);                      //Referenzdatum (festgelegt)
                    TimeSpan ts = new TimeSpan(localDateTime.Ticks - RefDate.Ticks);  // das Delta ermitteln
                    Datum = (uint)Convert.ToInt32(ts.TotalSeconds);

                    Strom = (float)Convert.ToDouble(arr[1]);
                    Gas = (float)Convert.ToDouble(arr[2]);
                    Wasser = (float)Convert.ToDouble(arr[3]);

                }
            }
        }
    }
}


